#!/usr/bin/python3
import pygame
from random import randint as ri

pygame.init()
default_font = pygame.font.SysFont("sans", 14)

def toggle_fullscreen(is_fullscreen):
    if is_fullscreen:
        pygame.display.set_mode((600,500),pygame.RESIZABLE)
    else:
        pygame.display.set_mode((0,0),pygame.FULLSCREEN)
    is_fullscreen = not is_fullscreen
    return is_fullscreen,pygame.display.get_window_size()

is_fullscreen = False
fill_screen = True
show_debug = False
inverse = False
screen = pygame.display.set_mode((600,500))#(0,0),pygame.FULLSCREEN)
is_fullscreen,screensize = toggle_fullscreen(is_fullscreen)
pygame.display.set_caption("Screensaver")
screensize = pygame.display.get_window_size()

clock = pygame.time.Clock()

scales = 1
speeds = 1

class DVD():
    def __init__(self,scale,speed):
        self.newcolor()
        self.dvd = pygame.image.load("dvd-logo.png")
        self.size = self.dvd.get_size()
        self.scale = scale
        self.speed = speed
        self.pos = ri(0,screensize[0]-self.size[0]),ri(0,screensize[1]-self.size[1])
        self.get_dvd(False)
        self.richtung = ["r","u"]
        

    def moving(self):
        dvdx,dvdy = self.pos
        if dvdx+self.scalesize[0] >= screensize[0]:
            self.richtung[0] = "l"
            self.newcolor()
        if dvdx <= 0:
            self.richtung[0] = "r"
            self.newcolor()
        if dvdy+self.scalesize[1] >= screensize[1]:
            self.richtung[1] = "o"
            self.newcolor()
        if dvdy <= 0:
            self.richtung[1] = "u"
            self.newcolor()

        if self.richtung[0] == "r":
            dvdx += self.speed
        else:
            dvdx -= self.speed
        if self.richtung[1] =="u":
            dvdy += self.speed
        else:
            dvdy -= self.speed
        self.pos = dvdx,dvdy

        
    def newcolor(self):
        self.color = (ri(0,255),ri(0,255),ri(0,255))

    def get_dvd(self,inverse):
        scaledx = self.size[0] * self.scale
        scaledy = self.size[1] * self.scale
        self.scalesize = (scaledx, scaledy)

        self.sdvd = pygame.Surface(self.scalesize, flags=pygame.SRCALPHA)
        
        pygame.draw.rect(self.sdvd, self.color, (0, 0, self.scalesize[0], self.scalesize[1]))
        self.sdvd.blit(pygame.transform.scale(self.dvd, self.scalesize), (0, 0))
        tempdvd = pygame.PixelArray(self.sdvd)
        if inverse :
            tempdvd.replace(self.color, (0,0,0,0))
            tempdvd.replace((0,0,0), self.color)
        else:
            tempdvd.replace((0,0,0), (0,0,0,0))
        del tempdvd

        screen.blit(self.sdvd, self.pos)


dvds = []
dvds.append(DVD(1,1))#ri(1,10)))


def get_debug_text():
    def text(text,line_counter):
        debug_text = default_font.render(str(text), True, (240, 240, 240))
        screen.blit(debug_text,(0,line_counter*default_font.get_height()))

    line_counter = 1
    globalvars =globals()
    for a in globalvars:
        text(f"{str(a)} = {str(globalvars[a])}",line_counter)
        line_counter += 1
    for a in dvds:
        text(vars(a),line_counter)
        line_counter += 1

running = True
if __name__ == "__main__":
    while running:
        if fill_screen:
            screen.fill((0,0,0))
        pressed_keys = pygame.key.get_pressed()

        if pressed_keys[pygame.K_ESCAPE]:
            exit()
        if pressed_keys[pygame.K_SPACE] and not preview_pressed_keys[pygame.K_SPACE]:
           fill_screen = not fill_screen
        if pressed_keys[pygame.K_d] and not preview_pressed_keys[pygame.K_d]:
           show_debug = not show_debug
        if pressed_keys[pygame.K_i] and not preview_pressed_keys[pygame.K_i]:
           inverse = not inverse
        if pressed_keys[pygame.K_f] and screen.get_size():
            is_fullscreen,screensize = toggle_fullscreen(is_fullscreen)
        if pressed_keys[pygame.K_UP] and speeds>=0:
            speeds += 1
        if pressed_keys[pygame.K_DOWN] and speeds>=1:
            speeds -= 1
        if pressed_keys[pygame.K_RIGHT] and scales>0.1:
            scales += 0.1
        if pressed_keys[pygame.K_LEFT] and scales>=0.2:
            scales -= 0.1
        if pressed_keys[pygame.K_PLUS] and not preview_pressed_keys[pygame.K_PLUS]:
           dvds.append(DVD(1,1)) #ri(1,30)))
        if pressed_keys[pygame.K_MINUS] and not preview_pressed_keys[pygame.K_MINUS] and not len(dvds) == 0:
           dvds.pop(0)

        preview_pressed_keys = pressed_keys

        for event in pygame.event.get():
            if event.type == pygame.QUIT:
                exit()
            if event.type == pygame.WINDOWRESIZED:
                screensize = pygame.display.get_window_size()
        
        for a in dvds:
            a.speed = speeds
            a.scale = scales
            a.moving()
            a.get_dvd(inverse)

        if show_debug:
            get_debug_text()
        pygame.display.flip()
        clock.tick(60)
